
__version__ = "$Revision: 14294 $"

import pygtk
pygtk.require('2.0')
import gtk

import gnomekeyring as gkey

class Keyring(object):
	def __init__(self, name, server, protocol,key):
		self._name = name
		self._server = server
		self._protocol = protocol
		self._key = key
		self._keyring = gkey.get_default_keyring_sync()

	def has_credentials(self):
		try:

			if self._key == gkey.ITEM_NETWORK_PASSWORD:
				attrs = {"server": self._server, "protocol": self._protocol}
				items = gkey.find_items_sync(gkey.ITEM_NETWORK_PASSWORD, attrs)
				return len(items) > 0
			if self._key == gkey.ITEM_GENERIC_SECRET:
				attrs = {"name": self._name}
				items = gkey.find_items_sync(gkey.ITEM_GENERIC_SECRET, attrs)
				return len(items) > 0
		except gkey.DeniedError:
		    return False

	def get_credentials(self):
		attrs = {"server": self._server, "protocol": self._protocol}
		items = gkey.find_items_sync(gkey.ITEM_NETWORK_PASSWORD, attrs)
		return (items[0].attributes["user"], items[0].secret)

	def set_credentials(self, (user, pw)):
		attrs = {
			"user": user,
			"server": self._server,
			"protocol": self._protocol,
		    }
		gkey.item_create_sync(gkey.get_default_keyring_sync(),
			gkey.ITEM_NETWORK_PASSWORD, self._name, attrs, pw, True)	

class KeyringWidget():

	username = "foo"
	password = ""

	def has_credentials(self):
		return	self.keyring.has_credentials()

	def setKeyRing(self,name , server , protocal):
		# name , server , protocal
		self.keyring = Keyring(name,server,protocal,gkey.ITEM_NETWORK_PASSWORD)

	def get_credentials(self):
		if self.keyring.has_credentials():
			credentials = self.keyring.get_credentials()
			self.nameentry.set_text(credentials[0])
			self.passentry.set_text(credentials[1])
			self.username = credentials[0]
			self.password = credentials[1]

	def updateCallback(self, widget, data=None):
		self.keyring.set_credentials([self.nameentry.get_text(), self.passentry.get_text()]) 
		self.username = self.nameentry.get_text()
		self.password = self.passentry.get_text()


	def __init__(self, name, server, protocol):
		self.frame = gtk.Frame(label="Account Details")

		vbox = gtk.VBox(homogeneous=False, spacing=0)
		self.frame.add(vbox)

		namelabel = gtk.Label("Username:")
		passlabel = gtk.Label("Password:")

		self.nameentry = gtk.Entry()
		self.passentry = gtk.Entry()

		vbox.add(namelabel)
		vbox.add(self.nameentry)
		vbox.add(passlabel)
		vbox.add(self.passentry)	

		self.updateButton = gtk.Button("Update Account")
	      # Connect the "clicked" signal of the button to our callback
		self.updateButton.connect("clicked", self.updateCallback )
	
		vbox.add(self.updateButton)

		namelabel.show()
		self.nameentry.show()
		passlabel.show()
		self.passentry.show()
		self.updateButton.show()
		self.frame.show()
		vbox.show()
		self.setKeyRing(name , server , protocol)
		self.get_credentials()
